VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "SDO_PDO_ISR"
   ClientHeight    =   4050
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4470
   LinkTopic       =   "Form1"
   ScaleHeight     =   4050
   ScaleWidth      =   4470
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   3360
      Top             =   120
   End
   Begin VB.CommandButton Btn_Clear 
      Caption         =   "Clear"
      Height          =   375
      Left            =   2880
      TabIndex        =   9
      Top             =   3600
      Width           =   1455
   End
   Begin VB.ListBox List_Monitor 
      Height          =   2205
      ItemData        =   "Form1.frx":0000
      Left            =   120
      List            =   "Form1.frx":0002
      TabIndex        =   8
      Top             =   1320
      Width           =   4215
   End
   Begin VB.CommandButton Btn_Initial 
      Caption         =   "Initial Master"
      Height          =   375
      Left            =   2880
      TabIndex        =   7
      Top             =   840
      Width           =   1455
   End
   Begin VB.CommandButton Btn_Shutdown 
      Caption         =   "Shutdown"
      Height          =   375
      Left            =   2880
      TabIndex        =   3
      Top             =   840
      Width           =   1455
   End
   Begin VB.ComboBox Combo_Node 
      Height          =   315
      ItemData        =   "Form1.frx":0004
      Left            =   1080
      List            =   "Form1.frx":0185
      TabIndex        =   2
      Top             =   840
      Width           =   1575
   End
   Begin VB.ComboBox Combo_Baud 
      Height          =   315
      ItemData        =   "Form1.frx":0470
      Left            =   1080
      List            =   "Form1.frx":048C
      TabIndex        =   1
      Top             =   480
      Width           =   1575
   End
   Begin VB.ComboBox Combo_Board 
      Height          =   315
      ItemData        =   "Form1.frx":04F2
      Left            =   1080
      List            =   "Form1.frx":0526
      TabIndex        =   0
      Top             =   120
      Width           =   1575
   End
   Begin VB.Label Label3 
      Caption         =   "Node ID"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   840
      Width           =   615
   End
   Begin VB.Label Label2 
      Caption         =   "Baud Rate"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   480
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Board No"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   120
      Width           =   735
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim Board As Byte
Dim Port As Byte
Dim BAUD As Byte
Public Node As Byte

Const BlockMode As Byte = 1

Dim Ret As Integer
Dim errstr As String

Private Sub Btn_Clear_Click()
    Call List_Monitor.Clear
End Sub

Private Sub Btn_Initial_Click()
    Dim Entry_Data(8) As Long

    Ret = CPM_InitMaster(Board, Port, Node, BAUD, BlockMode)
    If Ret <> 0 Then
        errstr = "Initial Error, = " + Str(Ret)
        MsgBox (errstr)
    Else
        Combo_Board.Enabled = False
        Combo_Baud.Enabled = False
        Combo_Node.Enabled = False

        Btn_Initial.Enabled = False
        Btn_Initial.Visible = False
        Btn_Shutdown.Enabled = True

        ' Install SDO read ISR
        Ret = CPM_InstallReadSDOISR(Board, Port, AddressOf UserRSDOISR)
        If Ret <> 0 Then
            errstr = "Install Read SDO ISR Error, = " + Str(Ret)
            MsgBox (errstr)
        End If

        ' Initial SDO write ISR
        Ret = CPM_InstallWriteSDOISR(Board, Port, AddressOf UserWSDOISR)
        If Ret <> 0 Then
            errstr = "Install Write SDO ISR Error, = " + Str(Ret)
            MsgBox (errstr)
        End If

        ' Install PDO output ISR
        Ret = CPM_InstallRxPDOISR(Board, Port, AddressOf UserRXPDOISR)
        If Ret <> 0 Then
            errstr = "Install output PDO ISR Error, = " + Str(Ret)
            MsgBox (errstr)
        End If

        ' The "EntryUse" parameter and "EntryData" parameter are useless
        ' when the PDO had been installed to master.
        Call CPM_InstallPDO_List(Board, Port, Node, &H200 + Node, 0, 1, 255, 0, 0, Entry_Data(0), BlockMode)

        ' Install PDO remote ISR
        Ret = CPM_InstallRemotePDOISR(Board, Port, AddressOf UserREMOTEPDOISR)
        If Ret <> 0 Then
            errstr = "Install remote PDO ISR Error, = " + Str(Ret)
            MsgBox (errstr)
        End If

        ' The "EntryUse" parameter and "EntryData" parameter are useless
        ' when the PDO had been installed to master.
        Call CPM_InstallPDO_List(Board, Port, Node, &H180 + Node, 1, 1, 255, 0, 0, Entry_Data(0), BlockMode)

        Timer1.Enabled = True

    End If
End Sub

Private Sub Btn_Shutdown_Click()

    Ret = CPM_ShutdownMaster(Board, Port)
    If Ret <> 0 Then
        errstr = "Shutdown Error, = " + Str(Ret)
        MsgBox (errstr)
    Else
        Combo_Board.Enabled = True
        Combo_Baud.Enabled = True
        Combo_Node.Enabled = True

        Btn_Initial.Enabled = True
        Btn_Initial.Visible = True
        Btn_Shutdown.Enabled = False

        Combo_Node.ListIndex = 0

        Call List_Monitor.Clear

        Timer1.Enabled = False
    End If
End Sub

Private Sub Combo_Baud_LostFocus()
    BAUD = Combo_Baud.ListIndex
End Sub

Private Sub Combo_board_LostFocus()
    Board = (Combo_Board.ListIndex)
End Sub

Private Sub Combo_Node_LostFocus()
    Node = Combo_Node.ListIndex + 1
End Sub

Private Sub Form_Load()
    Board = 0
    Port = 1
    BAUD = 0
    Node = 1

    Combo_Board.Enabled = True
    Combo_Baud.Enabled = True
    Combo_Node.Enabled = True

    Combo_Board.ListIndex = 0
    Combo_Baud.ListIndex = 0
    Combo_Node.ListIndex = 0

    RxSDO_Flag = False
    TxSDO_Flag = False
    RxPDO_Flag = False
    TxPDO_Flag = False

    Btn_Clear.Enabled = False

End Sub

Private Sub Form_Unload(Cancel As Integer)
    Call CPM_ShutdownMaster(Board, Port)
End Sub

Sub UserRSDO(Flag As Boolean)
    Dim Ret As Integer, Index As Integer
    Dim BoardNo As Byte, PortNo As Byte, SubIndex As Byte, RLen As Byte
    Dim RData(4) As Byte
    Dim Abort As Long
    
    Dim i As Integer
    Dim TempStr As String

    If Flag = False Then Exit Sub
    
    Ret = CPM_GetMasterReadSDOEvent(BoardNo, PortNo, Index, SubIndex)
    If Ret = 0 Then
        Select Case (Index)
            Case &H6000 ' Read DI (For CANopen SPC 401)
                Dim DI_Value As Byte

                DI_Value = 0
                Select Case (SubIndex)
                    Case &H0
                        ' DI entry number
                        RLen = 1
                        RData(0) = &H2  ' Ex: ch0~ch15, total 2-bytes (16-bits) DI data.
                    Case &H1
                        RLen = 1
                        DI_Value = 0

                        ' Read DI value of ch0 ~ ch7
                        ''''''''''''''''''''''''''''''''''''''''''''''
                        '  Write user's "Read DI Data function" here


                        ''''''''''''''''''''''''''''''''''''''''''''''
                        RData(0) = DI_Value
                    Case &H2
                        RLen = 1
                        DI_Value = 0

                        ' Read DI value of ch8 ~ ch15
                        ''''''''''''''''''''''''''''''''''''''''''''''
                        '  Write user's "Read DI Data function" here


                        ''''''''''''''''''''''''''''''''''''''''''''''
                        RData(0) = DI_Value
                    Case Else
                        Abort = &H6090011

                        ' Abort: Sub-index does not exist.
                        RLen = 4
                        RData(0) = &H11
                        RData(1) = &H0
                        RData(2) = &H9
                        RData(3) = &H6
                End Select
            Case &H6200 ' Read DO  (For CANopen SPC 401)
                Dim DO_Value As Byte

                DO_Value = 0
                Select Case (SubIndex)
                    Case &H0
                        ' DO entry number
                        RLen = 1
                        RData(0) = &H2  ' Ex: ch0~ch15, total 2-bytes (16-bits) DO data.
                    Case &H1
                        RLen = 1
                        DO_Value = 0

                        ' Read DO value of ch0 ~ ch7
                        ''''''''''''''''''''''''''''''''''''''''''''''
                        '  Write user's "Read DO Data function" here


                        ''''''''''''''''''''''''''''''''''''''''''''''
                        RData(0) = DO_Value
                    Case &H2
                        RLen = 1
                        DO_Value = 0

                        ' Read DO value of ch8 ~ ch15
                        ''''''''''''''''''''''''''''''''''''''''''''''
                        '  Write user's "Read DO Data function" here


                        ''''''''''''''''''''''''''''''''''''''''''''''
                        RData(0) = DO_Value
                    Case Else
                        Abort = &H6090011

                        ' Abort: Sub-index does not exist.
                        RLen = 4
                        RData(0) = &H11
                        RData(1) = &H0
                        RData(2) = &H9
                        RData(3) = &H6
                End Select
            Case Else
                Abort = &H6020000

                ' Abort: Object does not exist.
                RLen = 4
                RData(0) = &H0
                RData(1) = &H0
                RData(2) = &H2
                RData(3) = &H6
        End Select

        If (Abort = 0) Then
            Call CPM_ResponseMasterSDO(BoardNo, PortNo, 0, Index, SubIndex, RLen, RData(0))
            TempStr = "SDO Read"

        Else
            Call CPM_SDOAbortTransmit(BoardNo, PortNo, Form1.Node, Index, SubIndex, Abort, BlockMode)
            TempStr = "SDO Abort"
        End If

        TempStr = TempStr + " " + Right("0000" + Hex(Index), 4) + "-" + Right("00" + Hex(SubIndex), 2) + ":"

        If RLen <> 0 Then
            For i = 0 To RLen - 1

                TempStr = TempStr + " " + Right("00" + Hex(RData(i)), 2)
            Next i
        End If

        Call List_Monitor.AddItem(TempStr)
        RxSDO_Flag = False
    End If
End Sub

Sub UserWSDO(Flag As Boolean)
    Dim Ret As Integer, Index As Integer
    Dim BoardNo As Byte, PortNo As Byte, SubIndex As Byte, WLen As Byte
    Dim WData(4) As Byte
    Dim Abort As Long

    Dim i As Integer
    Dim TempStr As String

    If Flag = False Then Exit Sub
    
    Ret = CPM_GetMasterWriteSDOEvent(BoardNo, PortNo, Index, SubIndex, WLen, WData(0))
    If Ret = 0 Then
        Select Case (Index)
            Case &H6200 ' Write DO (For CANopen SPC 401)
                If (WLen <> 1) Then
                    Abort = &H6070010

                    ' Abort: Data type does not match, length of service parameter does not match
                    WLen = 4
                    WData(0) = &H10
                    WData(1) = &H0
                    WData(2) = &H7
                    WData(3) = &H6
                End If

                Select Case (SubIndex)
                    Case &H0
                        Abort = &H6010002

                        ' Abort: Attempt to write a read only object
                        WLen = 4
                        WData(0) = &H2
                        WData(1) = &H0
                        WData(2) = &H1
                        WData(3) = &H6
                    Case &H1
                        ' Output DO value of ch0 ~ ch7
                        ''''''''''''''''''''''''''''''''''''''''''''''
                        '  Write user's "Output DO Data function" here


                        ''''''''''''''''''''''''''''''''''''''''''''''
                    Case &H2
                        ' Output DO value of ch8 ~ ch15
                        ''''''''''''''''''''''''''''''''''''''''''''''
                        '  Write user's "Output DO Data function" here


                        ''''''''''''''''''''''''''''''''''''''''''''''
                    Case Else
                        Abort = &H6090011

                        ' Abort: Sub-index does not exist.
                        WLen = 4
                        WData(0) = &H11
                        WData(1) = &H0
                        WData(2) = &H9
                        WData(3) = &H6
                End Select
            Case Else
                Abort = &H6090011

                ' Abort: Object does not exist.
                WLen = 4
                WData(0) = &H11
                WData(1) = &H0
                WData(2) = &H9
                WData(3) = &H6
        End Select

        If (Abort = 0) Then
            Call CPM_ResponseMasterSDO(BoardNo, PortNo, 0, Index, SubIndex, WLen, WData(0))
            TempStr = "SDO Write " + Right("0000" + Hex(Index), 4) + "-" + Right("00" + Hex(SubIndex), 2) + ":  OK"

        Else
            Call CPM_SDOAbortTransmit(BoardNo, PortNo, Form1.Node, Index, SubIndex, Abort, BlockMode)
            TempStr = "SDO Abort " + Right("0000" + Hex(Index), 4) + "-" + Right("00" + Hex(SubIndex), 2) + ":"

            If WLen <> 0 Then
                For i = 0 To WLen - 1

                    TempStr = TempStr + " " + Right("00" + Hex(WData(i)), 2)
                Next i
            End If
        End If

        Call List_Monitor.AddItem(TempStr)
        TxSDO_Flag = False
    End If
End Sub

Sub UserRXPDO(Flag As Boolean)
    Dim Ret As Integer
    Dim BoardNo As Byte, PortNo As Byte, WLen As Byte
    Dim CobId As Integer, i As Integer
    Dim WData(8) As Byte
    Dim TempStr As String

    If Flag = False Then Exit Sub

    Ret = CPM_GetMasterRxPDOEvent(BoardNo, PortNo, CobId, WLen, WData(0))
    If Ret = 0 Then
        If (CobId = (&H200 + Form1.Node)) Then
            If (WLen >= 2) Then ' Ex: If user has 2-bytes DO data.

                ' Output DO value of ch0 ~ ch15
                ''''''''''''''''''''''''''''''''''''''''''''''
                '  Write user's "Output DO Data function" here


                ''''''''''''''''''''''''''''''''''''''''''''''

                TempStr = "PDO " + Right("000" + Hex(CobId), 3) + " Output:"
                If WLen <> 0 Then
                    For i = 0 To WLen - 1
                        TempStr = TempStr + " " + Right("00" + Hex(WData(i)), 2)
                    Next i
                End If

                Call List_Monitor.AddItem(TempStr)
                RxPDO_Flag = False
            End If
        End If
    End If
End Sub

Sub UserREMOTEPDO(Flag As Boolean)
    Dim Ret As Integer
    Dim BoardNo As Byte, PortNo As Byte, RLen As Byte
    Dim CobId As Integer, i As Integer
    Dim RData(8) As Byte
    Dim TempStr As String

    If Flag = False Then Exit Sub
    
    Ret = CPM_GetMasterRemotePDOEvent(BoardNo, PortNo, CobId)
    If Ret = 0 Then
        If CobId = (&H180 + Form1.Node) Then
            ' Ex: If user has 2-bytes DI data.
            RLen = 2

            ' Read DI value of ch0 ~ ch15
            ''''''''''''''''''''''''''''''''''''''''''''''
            '  Write user's "Read DI Data function" here


            ''''''''''''''''''''''''''''''''''''''''''''''

            TempStr = "PDO " + Right("000" + Hex(CobId), 3) + " Remote:"

            If RLen <> 0 Then
                For i = 0 To RLen - 1
                    TempStr = TempStr + " " + Right("00" + Hex(RData(i)), 2)
                Next i
            End If

            Call List_Monitor.AddItem(TempStr)
            TxPDO_Flag = False
        End If
    End If
End Sub

Private Sub Timer1_Timer()

    Call UserRSDO(RxSDO_Flag)
    
    Call UserWSDO(TxSDO_Flag)
    
    Call UserRXPDO(RxPDO_Flag)
    
    Call UserREMOTEPDO(TxPDO_Flag)
    
End Sub
